#include<gsl/gsl_matrix.h>
#include <gsl/gsl_permutation.h>
#include <gsl/gsl_rng.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_cblas.h>
#include <gsl/gsl_statistics_float.h> 
#include<cassert>
#include<ctime>
#include<vector>
#include <unistd.h>
#include <cstring>
#include<algorithm>
#include<cmath>
#include<stdio.h>
#include<wfdb/wfdb.h>
//#include "../bib/auxfunctions.h"

using namespace std;


int insertrecordallnoannot(char*recpath, int samplingfreq,
			   char*signaltype, vector<float>&longsignal);

using namespace std;

//write record ecg signal to txt file ./(rec.txt) using physical units value
// (floats)

int main(int argc, char** argv){

  // argv[1] is recordpath ex: mgh/mgh001
  //argv[2] is recname ex: mgh001

  int signalnumsamples;
  int notset=1;

  WFDB_Siginfo *s;
  int i, nsig;

  /* WFDB_Time t0, t1; */

  //char fname[200];
  //strcpy(fname,argv[2]);
  //strcat(fname,argv[1]);

  /*vector<float> signal;*/

  nsig = isigopen(argv[1], NULL, 0);
  if (nsig < 1) exit(2);
  s = (WFDB_Siginfo *)malloc(nsig * sizeof(WFDB_Siginfo));
  if (s == NULL) {
    fprintf(stderr, "insufficient memory\n");
    exit(3);
  }

  //save record information
  char signalfname[20];
  strcpy(signalfname,argv[2]);
  strcat(signalfname,"channelsinform.txt");
  FILE*fid=fopen(signalfname,"w");

  if (isigopen(argv[1], s, nsig) != nsig) exit(2);
  printf("Record %s\n", argv[1]);
 
  int start_time=0;
  int samplingfreq=sampfreq(argv[1]);

  printf("Starting time: %s\n",timstr(0L));
  printf("Sampling frequency: %d Hz\n", samplingfreq);
  fprintf(fid,"samplingfreq %d\n",samplingfreq);

  for (i = 0; i < nsig; i++) {

    char substr[4];
    strncpy(substr,s[i].desc,3);
    substr[3]='\0'; 
    if(strcmp("ECG",substr)==0){
      printf("signal %d is an ECG: %s\n", i,s[i].desc);
      fprintf(fid,"%d ECG\n",i);
      if (s[i].nsamp > 0L){ 
      /*printf(" Length: %s (%ld sample intervals)\n",
	timstr(s[i].nsamp), s[i].nsamp);*/
      if(notset){
	signalnumsamples=s[i].nsamp;
	notset=0;
      }
      else
	assert(signalnumsamples==s[i].nsamp);
      fprintf(fid,"signalnumsamples %d\n",signalnumsamples);
    }
    else printf(" Length undefined\n");  
  }
  else
    if((strcmp("BP",s[i].desc)==0)||(strcmp("ABP",s[i].desc)==0)||
       (strcmp("ART",s[i].desc)==0)||(strcmp("PAP",s[i].desc)==0)||
       (strcmp("CVP",s[i].desc)==0)||(strcmp("SV",s[i].desc)==0)){
      printf("signal %d is blood pressure: %s\n", i,s[i].desc);
      fprintf(fid,"%d bloodpressure\n",i);
      if (s[i].nsamp > 0L){ 
	/*printf(" Length: %s (%ld sample intervals)\n",
	  timstr(s[i].nsamp), s[i].nsamp);*/
	if(notset){
	  signalnumsamples=s[i].nsamp;
	  notset=0;
	}
	else
	  assert(signalnumsamples==s[i].nsamp);
	fprintf(fid,"signalnumsamples %d\n",signalnumsamples);
      }
      else printf(" Length undefined\n");
    } 
  }

  fclose(fid);
  return 0;
 
}
