#include <stdio.h>
#include <stdlib.h>
#include "beatlib.h"


int main ( int argc , char **argv ){
  
  char *qrsfilename = argv[1] ;
  char *wqrsfilename = argv[2] ;
  char *bxbfilename = argv[3] ;
  int lengthsignal = atoi(argv[4]) ;

  /* int limite = (TOLERANCE * fs)/1000 ; */
  int period = 10 ;
  int jump = 5 ;

  Beat_array *qrsbeats = Beat_array_from_File(qrsfilename) ;
  Beat_array *wqrsbeats = Beat_array_from_File(wqrsfilename) ;
  Beat_array *bxbbeats = Beat_array_from_File(bxbfilename) ;
  
  /* printf("%d %d\n" , qrsbeats->number , bxbbeats->number) ; */

  int LMAX , LMIN , LJUMP ;
  /* the interval length is 10 seconds , with 5 seconds overlap between consecutive intervals. */
  LJUMP = jump * qrsbeats->fs ;
  LMIN = 0 ;
  LMAX = period * qrsbeats->fs ;

  int contador_bxb = 1 ;
  int contador_qrs = 1 ;
  int contador_wqrs = 1 ;
  int indice_bxb = 0 ;
  int indice_qrs = 0 ;
  int indice_wqrs = 0 ;

  char tempomin[20] ;
  char tempomax[20] ;

  /* /\* the first thing is to see how many intervals will be necessary *\/ */
  /* while ( LMAX < qrsbeats->mem[qrsbeats->number - 1]){ */
  /*   LMAX += LJUMP ; */
  /*   contador_intervalos++ ; */
  /* } */
  
  int n_intervalos = (lengthsignal - LMAX)/LJUMP + 1 ;

  QBeat_array *intervalos = QBeat_array_init(n_intervalos) ;

  /* back to initial value */
  LMAX = period * qrsbeats->fs ;
  
  int i ;
  for ( i = 0 ; i < intervalos->number ; i++ ){
    intervalos->mem[i] = i ;
    intervalos->quality[i] = 1 ;
  }

  
  if ( bxbbeats->number < 1 );
    //printf("Nothing to report because there is a perfect match along all the record!\n" ) ;
  else {
    for ( i = 0 ; i < intervalos->number ; i++ )
      if (bxbbeats->mem[indice_bxb] > LMAX){
  	LMAX += LJUMP ;
  	LMIN += LJUMP ;
  	while (qrsbeats->mem[indice_qrs] < LMIN){
  	  indice_qrs++ ;
  	}
  	while (wqrsbeats->mem[indice_wqrs] < LMIN){
  	  indice_wqrs++ ;
  	}
      }
      else {
  	while (bxbbeats->mem[indice_bxb] < LMAX ) {
  	  indice_bxb++ ;
	  if ( indice_bxb < bxbbeats->number ) 
	    contador_bxb++ ;
  	}
  	contador_qrs = 1 ;
	contador_wqrs = 1 ;
  	while (qrsbeats->mem[indice_qrs] < LMAX){
  	  contador_qrs++ ;
  	  indice_qrs++ ;
  	}
  	while (wqrsbeats->mem[indice_wqrs] < LMAX){
  	  contador_wqrs++ ;
  	  indice_wqrs++ ;
  	}
  	intervalos->quality[i] = 1 - (2*contador_bxb + 0.0) / (contador_qrs + contador_wqrs + contador_bxb) ;
	timeformat(LMIN,qrsbeats->fs,tempomin) ;
	timeformat(LMAX,qrsbeats->fs,tempomax) ;
	/* printf("In interval [%s,%s] the quality is %f :: bxb -> %d gqrs -> %d wqrs -> %d\n",  */
	/* 	tempomin , tempomax , intervalos->quality[i] , contador_bxb , contador_qrs , contador_wqrs ) ; */
	contador_bxb = 1 ;
      }
  }
  
  for ( i = 0 ; i < intervalos->number ; i++ )
    printf("%f\n" , intervalos->quality[i] ) ;

  indice_wqrs = 0 ;
  indice_qrs = 0 ;
  indice_bxb = 0 ;

  Beat_array_free(qrsbeats) ;
  Beat_array_free(wqrsbeats) ;
  Beat_array_free(bxbbeats) ;
  QBeat_array_free(intervalos) ;

  return 0 ;
}
